#include<stdio.h>
#include<stdlib.h>
#include<string.h>


int main (int argc, char* argv[]) {
  FILE *fileRead;
  FILE *fileWrite;
  char table[10];
  char *table_modif;
  char url[1024];
  char c;
  int i,j,k,compt;
  char tab[]="\\.";
  char txt1[1024];
  char txt2[1024];
  int ent1,ent2,ent3,ent4;

  if (argc != 3) {
    printf("Arg incorrects\n");
    exit(EXIT_FAILURE);
  }
  fileRead = fopen(argv[1],"r");
  fileWrite = fopen(argv[2],"w");
  /*
  fileRead = fopen("moteur_web_img_01.sql","r");
  fileWrite = fopen("moteur_web_01.pl","w");
  */
  if(fileRead == NULL){
    printf("Echec de l'ouverture du fichier\n");
    return -1;
  }
  if(fileWrite == NULL){
    printf("Echech de l'ouverture du fichier bd.pl\n");
    return -1;
  }
  compt = 0;
  while(feof(fileRead) == 0){
    fread(&c,1,1,fileRead);
    if (c != 'C') {
      fgets(url,1024,fileRead);
      continue;
    }
    fread(&c,1,1,fileRead);
    if (c != 'O') {
      fgets(url,1024,fileRead);
      continue;
    }
    fscanf(fileRead,"%*s \"%s\" FROM stdin;\n",&table);
    table_modif= malloc(sizeof(char) * strlen(table)+1);
    for(i=0 ; i<strlen(table) ; i++)
      table_modif[i] = table[i];
    table_modif[strlen(table)-1] = '\0';
    fprintf(fileWrite,"/**\n * Table %s\n */\n\n",table_modif);
    fgets(url,1024,fileRead);
    while(!(url[0]=='\\' && url[1]=='.')){
      fgets(url,1024,fileRead);
      if(url[0]=='\\' && url[1]=='.') { // Fin de la table
        fprintf(fileWrite,"/* (%i entrees) */\n\n\n",compt);
        compt = 0;
	      break;
      }
      // Copie des entres
      /*
      if (strcmp("serveur",table_modif) == 0) {
        sscanf(url,"%s\t%i\n",&txt1,&ent1);
        fprintf(fileWrite,"%s('%s',%i).\n",table_modif,txt1,ent1);
      }
      else if (strcmp("img",table_modif) == 0) {
        sscanf(url,"%i\t%s\t%s\t%i\n",&ent1,&txt1,&txt2,&ent2);
        fprintf(fileWrite,"%s(%i,'%s','%s',%i).\n",table_modif,ent1,txt1,txt2,ent2);
      }
      else if (strcmp("page",table_modif) == 0) {
        sscanf(url,"%i\t%s\t%i\t%i\n",&ent1,&txt1,&ent2,&ent3);
        fprintf(fileWrite,"%s(%i,'%s',%i,%i).\n",table_modif,ent1,txt1,ent2,ent3);
      }
      else if (strcmp("fichier",table_modif) == 0) {
        sscanf(url,"%s\t%s\t%i\n",&txt1,&txt2,&ent2);
        fprintf(fileWrite,"%s('%s','%s',%i).\n",table_modif,txt1,txt2,ent2);
      }
      else if (strcmp("doc_txt",table_modif) == 0) {
        sscanf(url,"%i\n",&ent1);
        fprintf(fileWrite,"%s(%i).\n",table_modif,ent1);
      }
      else if (strcmp("protocole",table_modif) == 0) {
        sscanf(url,"%s\t%i\n",&txt1,&ent1);
        fprintf(fileWrite,"%s('%s',%i).\n",table_modif,txt1,ent1);
      }
      else if (strcmp("heberge",table_modif) == 0) {
        sscanf(url,"%i\t%i\t%i\n",&ent1,&ent2,&ent3);
        fprintf(fileWrite,"%s(%i,%i,%i).\n",table_modif,ent1,ent2,ent3);
      }
      else if (strcmp("mot_txt",table_modif) == 0) {
        sscanf(url,"%s\t%i\n",&txt1,&ent1);
        fprintf(fileWrite,"%s('%s',%i).\n",table_modif,txt1,ent1);
      }
      else if (strcmp("txt_doc",table_modif) == 0) {
        sscanf(url,"%i\t%i\t%i\n",&ent1,&ent2,&ent3);
        fprintf(fileWrite,"%s(%i,%i,%i).\n",table_modif,ent1,ent2,ent3);
      }
      else if (strcmp("txt_page",table_modif) == 0) {
        sscanf(url,"%i\t%i\t%i\n",&ent1,&ent2,&ent3);
        fprintf(fileWrite,"%s(%i,%i,%i).\n",table_modif,ent1,ent2,ent3);
      }
      else if (strcmp("mot_desc",table_modif) == 0) {
        sscanf(url,"%s\t%i\n",&txt1,&ent1);
        fprintf(fileWrite,"%s('%s',%i).\n",table_modif,txt1,ent1);
      }
      else if (strcmp("href",table_modif) == 0) {
        sscanf(url,"%i\t%i\t%i\n",&ent1,&ent2,&ent3);
        fprintf(fileWrite,"%s(%i,%i,%i).\n",table_modif,ent1,ent2,ent3);
      }
      else if (strcmp("app_href",table_modif) == 0) {
        sscanf(url,"%i\t%i\t%i\t%i\n",&ent1,&ent2,&ent3,&ent4);
        fprintf(fileWrite,"%s(%i,%i,%i,%i).\n",table_modif,ent1,ent2,ent3,ent4);
      }
      else if (strcmp("mail",table_modif) == 0) {
        sscanf(url,"%s\t%i\n",&txt1,&ent1);
        fprintf(fileWrite,"%s('%s',%i).\n",table_modif,txt1,ent1);
      }
      else if (strcmp("app_mail",table_modif) == 0) {
        sscanf(url,"%i\t%i\t%i\t%i\n",&ent1,&ent2,&ent3,&ent4);
        fprintf(fileWrite,"%s(%i,%i,%i,%i).\n",table_modif,ent1,ent2,ent3,ent4);
      }
      else if (strcmp("app_img",table_modif) == 0) {
        sscanf(url,"%i\t%i\t%i\t%i\n",&ent1,&ent2,&ent3,&ent4);
        fprintf(fileWrite,"%s(%i,%i,%i,%i).\n",table_modif,ent1,ent2,ent3,ent4);
      }
      */
      if (table_modif[0] == 's') {
        sscanf(url,"%s\t%i\n",&txt1,&ent1);
        fprintf(fileWrite,"%s('%s',%i).\n",table_modif,txt1,ent1);
      }
      else if (table_modif[0] == 'i') {
        sscanf(url,"%i\t%s\t%s\t%i\n",&ent1,&txt1,&txt2,&ent2);
        fprintf(fileWrite,"%s(%i,'%s','%s',%i).\n",table_modif,ent1,txt1,txt2,ent2);
      }
      else if ((table_modif[0] == 'p') && (table_modif[1] == 'a')) {
        sscanf(url,"%i\t%s\t%i\t%i\n",&ent1,&txt1,&ent2,&ent3);
        fprintf(fileWrite,"%s(%i,'%s',%i,%i).\n",table_modif,ent1,txt1,ent2,ent3);
      }
      else if (table_modif[0] == 'f') {
        sscanf(url,"%s\t%s\t%i\n",&txt1,&txt2,&ent2);
        fprintf(fileWrite,"%s('%s','%s',%i).\n",table_modif,txt1,txt2,ent2);
      }
      else if (table_modif[0] == 'd') {
        sscanf(url,"%i\n",&ent1);
        fprintf(fileWrite,"%s(%i).\n",table_modif,ent1);
      }
      else if ((table_modif[0] == 'p') && (table_modif[1] == 'r')) {
        sscanf(url,"%s\t%i\n",&txt1,&ent1);
        fprintf(fileWrite,"%s('%s',%i).\n",table_modif,txt1,ent1);
      }
      else if (table_modif[0] == 'h') {
        sscanf(url,"%i\t%i\t%i\n",&ent1,&ent2,&ent3);
        fprintf(fileWrite,"%s(%i,%i,%i).\n",table_modif,ent1,ent2,ent3);
      }
      else if (table_modif[0] == 'm') {
        sscanf(url,"%s\t%i\n",&txt1,&ent1);
        fprintf(fileWrite,"%s('%s',%i).\n",table_modif,txt1,ent1);
      }
      else if (table_modif[0] == 't') {
        sscanf(url,"%i\t%i\t%i\n",&ent1,&ent2,&ent3);
        fprintf(fileWrite,"%s(%i,%i,%i).\n",table_modif,ent1,ent2,ent3);
      }
      else if (table_modif[0] == 'a') {
        sscanf(url,"%i\t%i\t%i\t%i\n",&ent1,&ent2,&ent3,&ent4);
        fprintf(fileWrite,"%s(%i,%i,%i,%i).\n",table_modif,ent1,ent2,ent3,ent4);
      }
      compt ++;
    }
  }

  fclose(fileRead);
  fclose(fileWrite);
  free(table_modif);
}
